      ; Contribution to the #amycoders shortest gravity particle compo
      ; by Psycho/Loonies <psycho@mail.org>

      ; Code size without last rts: 76 bytes

      ; A0: Pointer to chunky buffer (256*256*8)
      ; A1: Pointer to particles ( word px,py,vx,vy, all 12.4 fixpoint)

GravityParticle
      move.w #4096-1,d7         ;4    number of dots
      moveq #12,d5              ;2    gravity-constant
.loop
      move.l #(128*16+1)*65536+128*16,d0  ;6
      move.l (a1)+,d4           ;2    get p=y:x
      sub.l d4,d0               ;2    pdist=(128:128)-p
      move.w d0,d2              ;2
      muls.w d2,d2              ;2    xdist^2
      move.l d0,d1              ;2
      swap d1                   ;2
      muls.w d1,d1              ;2    ydist^2
      add.l d1,d2               ;2    len=xdist^2+ydist^2

      bset d5,d2                ;2    ensure no division by zero
      lsr.l d5,d2               ;2    len/=2048
      move.w d0,d1              ;2    save xdist
      ext.l d1                  ;2
      divs.w d2,d1              ;2    dvx=xdist/len
      divs.l d2,d0              ;4    dvy*ffff=ydist*ffff/len
      move.w d1,d0              ;2    dv=ydist/len:xdist/len

      add.l d0,(a1)             ;2    v+=dv
      add.l (a1)+,d4            ;2    p+=v
      move.l d4,-8(a1)          ;4    save p

      move.l d4,d0              ;2
      and.l #$f000f000,d0       ;6    anything else than the [0-255],[0-255] interval?
      bne.s .next               ;2
      lsr.l #4,d4               ;2    0y0x
      lsl.w #8,d4               ;2    0yx0
      lsr.l #8,d4               ;2    00yx
      move.b d5,(a0,d4.l)       ;4    plot
.next
      dbra.s d7,.loop           ;4
      rts                       ;76

 

