SoCalledGravityParticles:
	; Entry for the #amycoders Gravity Particle compo
	; by Blueberry of Efreet. Size: 68 bytes.
	; With adjustable gravity and high accuracy.

	; Adding "1" to r has no noticable effect on the movement
	; just a few pixels away from the center. Close to the center
	; it even reduces the "stray-pixels" effect.

Gravity = 15	; (1/gravity as defined in the compo text.)

	; A0 = Chunky
	; A1 = Particles
a
	clr.w	d7
.loop:
	move.l	a1,a2
	moveq.l	#1,d1		; Add ~ 0.004 to avoid dividing by 0...
.l1:	move.w	d3,d2
	moveq.l	#128>>4,d0
	lsl.w	#8,d0		; Center = 128.0
	sub.w	(a1)+,d0
	move.l	d0,d3		; Upper word of D3 is now clear.
	muls.w	d0,d0
	add.l	d0,d1
	not.w	d7
	bmi.b	.l1
.l2:	muls.w	#Gravity<<8,d2	; dif*G
	divs.l	d1,d2		; dif*G/r
	add.w	(a1),d2		; v+dif*G/r
	move.w	d2,(a1)+	; -> v
	add.w	d2,(a2)+	; p = p + v
	move.w	d3,d2
	not.w	d7
	bmi.b	.l2
	move.l	-(a2),d0	; XXXxYYYy
	rol.w	#4,d0		; XXXxYYyY
	move.w	d0,d3		; 0000YYyY
	rol.l	#4,d0		; XXxYYyYX
	tst.b	d0
	bne.b	.out		; x or y negative or >255, skip.
	rol.l	#8,d0		; xYYy00XX
	move.b	d0,d3		, 0000YYXX
	st.b	(a0,d3.l)
.out:	addq.w	#8,d7
	bpl.b	.loop
b
	rts

	printv	b-a

